/*
 * OOoPresentationHelper.java
 *
 * Created on June 10, 2006, 12:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.reeven.van.nljug.ooo;

import com.sun.star.awt.FontWeight;
import com.sun.star.awt.Point;
import com.sun.star.awt.Size;
import com.sun.star.beans.Property;
import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.XPropertySet;
import com.sun.star.beans.XPropertySetInfo;
import com.sun.star.drawing.XDrawPage;
import com.sun.star.drawing.XDrawPages;
import com.sun.star.drawing.XDrawPagesSupplier;
import com.sun.star.drawing.XMasterPageTarget;
import com.sun.star.drawing.XMasterPagesSupplier;
import com.sun.star.drawing.XShape;
import com.sun.star.drawing.XShapes;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.lang.WrappedTargetException;
import com.sun.star.lang.IndexOutOfBoundsException;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XServiceInfo;
import com.sun.star.presentation.XHandoutMasterSupplier;
import com.sun.star.presentation.XPresentation;
import com.sun.star.presentation.XPresentationPage;
import com.sun.star.presentation.XPresentationSupplier;
import com.sun.star.style.ParagraphAdjust;
import com.sun.star.text.ControlCharacter;
import com.sun.star.text.XText;
import com.sun.star.text.XTextCursor;
import com.sun.star.uno.UnoRuntime;

/**
 *
 * @author wouter
 */
public class OOoPresentationHelper {
    
// <editor-fold defaultstate="collapsed" desc="Declared variables">
    // Define several constants
    
    // Layout constants, since this is not documented anywhere
    public final int TITLE_SLIDE = 0;
    public final int TITLE_TEXT_SLIDE = 1;
    public final int TITLE_CHART_SLIDE = 2;
    public final int TITLE_2_TEXT_BLOCKS_SLIDE = 3;
    public final int TITLE_TEXT_CHART_SLIDE = 4;
    public final int TITLE_TEXT_CLIPART_SLIDE = 6;
    public final int TITLE_CHART_TEXT_SLIDE = 7;
    public final int TITLE_SPREADSHEET_SLIDE = 8;
    public final int TITLE_CLIPART_TEXT_SLIDE = 9;
    public final int TITLE_TEXT_OBJECT_SLIDE = 10;
    public final int TITLE_OBJECT_SLIDE = 11;
    public final int TITLE_TEXT_2_OBJECTS_SLIDE = 12;
    public final int TITLE_OBJECT_TEXT_SLIDE = 13;
    public final int TITLE_OBJECT_ABOVE_TEXT_SLIDE = 14;
    public final int TITLE_2_OBJECTS_TEXT_SLIDE = 15;
    public final int TITLE_2_OBJECTS_ABOVE_TEXT_SLIDE = 16;
    public final int TITLE_TEXT_ABOVE_OBJECT_SLIDE = 17;
    public final int TITLE_4_OBJECTS_SLIDE = 18;
    public final int TITLE_ONLY_SLIDE = 19;
    public final int BLANK_SLIDE = 20;
    
    private XPresentation xPresentation;
    
    // some properties of the presentation slides
    private int Y_OFFSET = 600;
    private OOoPresentationContents oooPresentationContents = new OOoPresentationContents();
//</editor-fold>
    
    /** Creates a new instance of OOoPresentationHelper */
    public OOoPresentationHelper() {
    }

    
// methods to access overall Presentation related components
// <editor-fold defaultstate="collapsed" desc="overall Presentation related components">
    
    public XComponent getPresentationComponent(Object desktop, String templateURL) throws Exception {
        XComponentLoader xComponentLoader = (XComponentLoader)UnoRuntime.queryInterface(XComponentLoader.class, desktop);
        PropertyValue[] pPropValues = new PropertyValue[2];
        pPropValues[0] = new PropertyValue();
        pPropValues[0].Name = "ReadOnly";
        pPropValues[0].Value = new Boolean(true);
        pPropValues[1] = new PropertyValue();
        pPropValues[1].Name = "Hidden";
        pPropValues[1].Value = new Boolean(true);
        return xComponentLoader.loadComponentFromURL(templateURL, "_blank", 0, pPropValues);
    }
    
    public XPresentation getPresentation(XComponent xPresentationComponent) throws Exception {
        XPresentationSupplier xPresSupplier = (XPresentationSupplier)UnoRuntime.queryInterface(XPresentationSupplier.class, xPresentationComponent);
        return xPresSupplier.getPresentation();
    }

    public void runPresentation() throws Exception {
        this.setXPresentation(xPresentation);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xPresentation);
        xPresPropSet.setPropertyValue("IsFullScreen", new Boolean(true));
        xPresentation.start();
    }
    
    public boolean isImpressDocument(XComponent xComponent) {
        XServiceInfo xInfo = (XServiceInfo)UnoRuntime.queryInterface(XServiceInfo.class, xComponent);		
        return xInfo.supportsService("com.sun.star.presentation.PresentationDocument");
    }
    
    public void setXPresentation(XPresentation xPresentation) {
        this.xPresentation = xPresentation;
    }

// </editor-fold>
    
// methods to access XDrawPage components
// <editor-fold defaultstate="collapsed" desc="XDrawPage components">

    public int getDrawPageCount(XComponent xComponent) {
        XDrawPagesSupplier xDrawPagesSupplier = (XDrawPagesSupplier)UnoRuntime.queryInterface(XDrawPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xDrawPagesSupplier.getDrawPages();
        return xDrawPages.getCount();
    }
    
    public XDrawPage getDrawPageByIndex(XComponent xComponent, int nIndex) throws com.sun.star.lang.IndexOutOfBoundsException, com.sun.star.lang.WrappedTargetException {
        XDrawPagesSupplier xDrawPagesSupplier = (XDrawPagesSupplier)UnoRuntime.queryInterface(XDrawPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xDrawPagesSupplier.getDrawPages();
        return (XDrawPage)UnoRuntime.queryInterface(XDrawPage.class, xDrawPages.getByIndex(nIndex));
    }

    public XDrawPage insertNewDrawPageByIndex(XComponent xComponent, int nIndex) throws Exception {
        XDrawPagesSupplier xDrawPagesSupplier = (XDrawPagesSupplier)UnoRuntime.queryInterface(XDrawPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xDrawPagesSupplier.getDrawPages();
        return xDrawPages.insertNewByIndex(nIndex);
    }

    public void removeDrawPage(XComponent xComponent, XDrawPage xDrawPage) {
        XDrawPagesSupplier xDrawPagesSupplier = (XDrawPagesSupplier)UnoRuntime.queryInterface(XDrawPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xDrawPagesSupplier.getDrawPages();
        xDrawPages.remove(xDrawPage);
    }

    public Size getPageSize(XDrawPage xDrawPage) throws com.sun.star.beans.UnknownPropertyException, com.sun.star.lang.WrappedTargetException {
        XPropertySet xPageProperties = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        return new Size(((Integer)xPageProperties.getPropertyValue("Width")).intValue(), ((Integer)xPageProperties.getPropertyValue("Height")).intValue());
    }
// </editor-fold>
        
// methods to access MasterPage components
// <editor-fold defaultstate="collapsed" desc="MasterPage components">

    public int getMasterPageCount(XComponent xComponent) {
        XMasterPagesSupplier xMasterPagesSupplier = (XMasterPagesSupplier)UnoRuntime.queryInterface(XMasterPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xMasterPagesSupplier.getMasterPages();
        return xDrawPages.getCount();
    }

    public XDrawPage getMasterPageByIndex(XComponent xComponent, int nIndex) throws IndexOutOfBoundsException, WrappedTargetException {
        XMasterPagesSupplier xMasterPagesSupplier = (XMasterPagesSupplier)UnoRuntime.queryInterface( XMasterPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xMasterPagesSupplier.getMasterPages();
        return (XDrawPage)UnoRuntime.queryInterface(XDrawPage.class, xDrawPages.getByIndex(nIndex));
    }

    public XDrawPage insertNewMasterPageByIndex(XComponent xComponent, int nIndex) {
        XMasterPagesSupplier xMasterPagesSupplier = (XMasterPagesSupplier)UnoRuntime.queryInterface( XMasterPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xMasterPagesSupplier.getMasterPages();
        return xDrawPages.insertNewByIndex(nIndex);
    }

    public void removeMasterPage(XComponent xComponent, XDrawPage xDrawPage) {
        XMasterPagesSupplier xMasterPagesSupplier = (XMasterPagesSupplier)UnoRuntime.queryInterface(XMasterPagesSupplier.class, xComponent);
        XDrawPages xDrawPages = xMasterPagesSupplier.getMasterPages();
        xDrawPages.remove(xDrawPage);
    }

    public XDrawPage getMasterPage(XDrawPage xDrawPage) {
        XMasterPageTarget xMasterPageTarget = (XMasterPageTarget)UnoRuntime.queryInterface(XMasterPageTarget.class, xDrawPage);
        return xMasterPageTarget.getMasterPage();
    }

    public void setMasterPage(XDrawPage xDrawPage, XDrawPage xMasterPage) {
        XMasterPageTarget xMasterPageTarget = (XMasterPageTarget)UnoRuntime.queryInterface(XMasterPageTarget.class, xDrawPage);
        xMasterPageTarget.setMasterPage(xMasterPage);
    }
// </editor-fold>
    
// methods to access NotesPage components
// <editor-fold defaultstate="collapsed" desc="NotesPage components">

    public XDrawPage getNotesPage(XDrawPage xDrawPage) {
        XPresentationPage aPresentationPage = (XPresentationPage)UnoRuntime.queryInterface(XPresentationPage.class, xDrawPage);
        return aPresentationPage.getNotesPage();
    }
// </editor-fold>
    
// methods to access HandoutMasterPage components
// <editor-fold defaultstate="collapsed" desc="HandoutMasterPage components">

    public XDrawPage getHandoutMasterPage(XComponent xComponent) {
        XHandoutMasterSupplier aHandoutMasterSupplier = (XHandoutMasterSupplier)UnoRuntime.queryInterface(XHandoutMasterSupplier.class, xComponent);
        return aHandoutMasterSupplier.getHandoutMasterPage();
    }
// </editor-fold>
    
// methods to modify individual pages
// <editor-fold defaultstate="collapsed" desc="individual pages">
    
    public void setTitlePage(XComponent xPresentationComponent, String titleText) throws Exception {
        XDrawPage xDrawPage = getDrawPageByIndex(xPresentationComponent, 0);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(1);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        if (titleText == null || titleText.equals("")) {
            xText.setString("The OpenOffice.org API");
        } else {
            xText.setString(titleText);
        }
    }

    public void addContentsPage(XComponent xPresentationComponent, int pageIndex, int historyIndex) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC_TITLE);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.TOC.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.TOC[i]);
            xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
            xPropertySet.getPropertyValue("CharColor");
            if (historyIndex - i == 1 || historyIndex == 0) {
                xPropertySet.setPropertyValue("CharColor", charColor);
            } else {
                xPropertySet.setPropertyValue("CharColor", new Integer(0x00b3b3b3));
            }
            if (i < oooPresentationContents.TOC.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }
        
        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addHistoryPage(XComponent xPresentationComponent, int pageIndex) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[0]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.HISTORY.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.HISTORY[i]);
            if (i < oooPresentationContents.HISTORY.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addUnoOverviewPage(XComponent xPresentationComponent, int pageIndex) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[1]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.UNO_OVERVIEW.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.UNO_OVERVIEW[i]);
            if (i == 2) {
                xTextCursor.gotoEnd(false);
                xTextCursor.goLeft((short)15, true);
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue ("CharWeight", new Float(FontWeight.BOLD));
                xTextCursor.gotoEnd(false);
            } else {
                xTextCursor.gotoEnd(true);
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue ("CharWeight", new Float(FontWeight.NORMAL));
            }
            if (i < oooPresentationContents.UNO_OVERVIEW.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addUnoApiPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[1]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.UNO_API.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.UNO_API[i]);
            
            if (i == 1 || i == 4) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)1));
            }
            if (i == 3) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)0));
            }
            
            if (i < oooPresentationContents.UNO_API.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addUnoApiConsistsPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[1]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.UNO_API_CONSISTS.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.UNO_API_CONSISTS[i]);
            
            if (i == 1 || i == 3 || i == 5 || i == 7 || i == 9 || i == 11) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)1));
            }
            if (i == 2 || i == 4 || i == 6 || i == 8 || i == 10) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)2));
            }
            
            if (i < oooPresentationContents.UNO_API_CONSISTS.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addUnoApiDrawbacksPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[1]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.UNO_API_DRAWBACKS.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.UNO_API_DRAWBACKS[i]);
            
            if (i == 1) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)1));
            }
            if (i == 4) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            }
            if (i == 5) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)0));
            }
            
            if (i < oooPresentationContents.UNO_API_DRAWBACKS.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addUnoApiWorkFlowPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[1]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.UNO_API_WORKFLOW.length; i++) {
            xTextCursor.gotoEnd(false);
            xTextCursor.setString(oooPresentationContents.UNO_API_WORKFLOW[i]);
            
            if (i == 1) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)1));
            }
            if (i == 7) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)0));
            }
            
            if (i < oooPresentationContents.UNO_API_WORKFLOW.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaLocalConnectionPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.JAVA_LOCAL_CONNECTION.length; i++) {
            xTextCursor.gotoEnd(false);
            
            xTextCursor.setString(oooPresentationContents.JAVA_LOCAL_CONNECTION[i]);
            
            if (i > 0) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Courier New");
                xPropertySet.setPropertyValue("CharHeight", 18.0f);
            }

            xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaRemoteConnectionPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.JAVA_REMOTE_CONNECTION.length; i++) {
            xTextCursor.gotoEnd(false);
            
            xTextCursor.setString(oooPresentationContents.JAVA_REMOTE_CONNECTION[i]);
            
            if (i > 0) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Courier New");
                xPropertySet.setPropertyValue("CharHeight", 14.0f);
            }
            
            if (i == 5) {
                xTextCursor.gotoEnd(false);
                xTextCursor.goLeft((short)115, true);
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue ("CharWeight", new Float(FontWeight.BOLD));
                xTextCursor.gotoEnd(false);
            } else {
                xTextCursor.gotoEnd(true);
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue ("CharWeight", new Float(FontWeight.NORMAL));
            }

            if (i == 0) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            }
            xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaRemoteServerPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.JAVA_REMOTE_SERVER.length; i++) {
            xTextCursor.gotoEnd(false);
            
            xTextCursor.setString(oooPresentationContents.JAVA_REMOTE_SERVER[i]);

            if (i == 1 || i == 3) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Courier New");
                xPropertySet.setPropertyValue("CharHeight", 18.0f);
            } else {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Arial");
                xPropertySet.setPropertyValue("CharHeight", 28.0f);
            }
            if (i <= 3) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            }
            if (i == 3) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaLoadDocument(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.JAVA_LOAD_DOCUMENT.length; i++) {
            xTextCursor.gotoEnd(false);
            
            xTextCursor.setString(oooPresentationContents.JAVA_LOAD_DOCUMENT[i]);

            if (i == 1 || i == 2 || i == 3 || i == 5 || i == 6 || i == 7 || i == 8) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Courier New");
                xPropertySet.setPropertyValue("CharHeight", 18.0f);
            } else {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("CharFontName", "Arial");
                xPropertySet.setPropertyValue("CharHeight", 28.0f);
            }
            if (i == 1 || i == 2 || i == 5 || i == 6 || i == 7) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            }
            if (i == 0 || i == 4) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
            }
            if (i == 3) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaDemoPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        xText.insertControlCharacter(xTextCursor, ControlCharacter.LINE_BREAK,false);
        xTextCursor.gotoEnd(false);

        xTextCursor.setString(oooPresentationContents.JAVA_DEMO);
        xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        xPropertySet.setPropertyValue("IsNumbering", false);
        xPropertySet.setPropertyValue("ParaAdjust", ParagraphAdjust.CENTER);

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

    public void addJavaTextDocumentsPage(XComponent xPresentationComponent, int pageIndex, XPresentation xPresentation) throws Exception {
        XDrawPage xDrawPage = insertNewDrawPageByIndex(xPresentationComponent,pageIndex);
        XPropertySet xPresPropSet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xDrawPage);
        xPresPropSet.setPropertyValue("Layout", new Integer(TITLE_TEXT_SLIDE));
        XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
        Object xObj = xShapes.getByIndex(0);
        XShape xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        XText xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        xText.setString(oooPresentationContents.TOC[2]);

        xObj = xShapes.getByIndex(1);
        xShape = (XShape)UnoRuntime.queryInterface(XShape.class, xObj);
        xText = (XText)UnoRuntime.queryInterface(XText.class, xShape);
        XTextCursor xTextCursor = xText.createTextCursor();
        xTextCursor.gotoStart(false);
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
        Object charColor = xPropertySet.getPropertyValue("CharColor");
        for (int i = 0; i < oooPresentationContents.JAVA_TEXT_DOCUMENTS.length; i++) {
            xTextCursor.gotoEnd(false);
            
            xTextCursor.setString(oooPresentationContents.JAVA_TEXT_DOCUMENTS[i]);

            if (i == 1 || i == 3 || i == 5 || i == 7 || i == 9) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)1));
            }
            if (i == 2 || i == 4 || i == 6 || i == 8) {
                xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xTextCursor);
                xPropertySet.setPropertyValue("NumberingLevel", new Short((short)2));
            }
            
            if (i < oooPresentationContents.JAVA_TEXT_DOCUMENTS.length-1) {
                xText.insertControlCharacter(xTextCursor, ControlCharacter.PARAGRAPH_BREAK,false);
            }
        }

        Size size = xShape.getSize();
        Point point = xShape.getPosition();
        point.Y += Y_OFFSET;
        xShape.setPosition(point);
        xShape.setSize(size);
    }

// </editor-fold>
    
}
