/*
 * AddTemplateForm.java
 *
 * Created on June 8, 2006, 8:49 PM
 */

package nl.reeven.van.nljug.presentation;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

/**
 *
 * @author  wouter
 */
public class AddTemplateForm extends JFrame {
    
    private Properties templateNames;
    private JComboBox templateComboBox;
    private static final String PREFSDIR = ".oopresentation";
    private static final String PREFSFILE = "templates.properties";
    
    /** Creates new form AddTemplateForm */
    public AddTemplateForm(Properties templateNames, JComboBox templateComboBox) {
        this.templateNames = templateNames;
        this.templateComboBox = templateComboBox;
        initComponents();
        setExtendedState(JFrame.MAXIMIZED_BOTH);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        centerPanel = new javax.swing.JPanel();
        templateLabel = new javax.swing.JLabel();
        templateTextField = new javax.swing.JTextField();
        templateButton = new javax.swing.JButton();
        nameLabel = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();

        okButton.setFont(new java.awt.Font("Arial", 1, 24));
        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(okButton);

        cancelButton.setFont(new java.awt.Font("Arial", 1, 24));
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(cancelButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

        centerPanel.setLayout(new java.awt.GridBagLayout());

        templateLabel.setFont(new java.awt.Font("Arial", 0, 24));
        templateLabel.setText("Select template location");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(templateLabel, gridBagConstraints);

        templateTextField.setColumns(30);
        templateTextField.setEditable(false);
        templateTextField.setFont(new java.awt.Font("Arial", 0, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(templateTextField, gridBagConstraints);

        templateButton.setFont(new java.awt.Font("Arial", 1, 24));
        templateButton.setText("Select file...");
        templateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                templateButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(templateButton, gridBagConstraints);

        nameLabel.setFont(new java.awt.Font("Arial", 0, 24));
        nameLabel.setText("Enter template name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(nameLabel, gridBagConstraints);

        nameTextField.setColumns(15);
        nameTextField.setFont(new java.awt.Font("Arial", 0, 24));
        nameTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nameTextFieldActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(nameTextField, gridBagConstraints);

        getContentPane().add(centerPanel, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        String templateFileName = templateTextField.getText();
        if (!templateFileName.startsWith("/")) {
            templateFileName = "/" + templateFileName;
        }
        templateFileName = "file://" + templateFileName.replaceAll("\\\\", "/");
        templateNames.put(nameTextField.getText(), templateFileName);
        templateComboBox.addItem(nameTextField.getText());
        String userHome = System.getProperty("user.home");
        File prefsDir = new File(userHome + System.getProperty("file.separator") + PREFSDIR);
        File ooTemplates = new File(prefsDir.getPath() + System.getProperty("file.separator") + PREFSFILE);
        try {
            FileOutputStream out = new FileOutputStream(ooTemplates);
            templateNames.store(out,"--No Comments--");
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void templateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_templateButtonActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.addChoosableFileFilter(new PresentationFileFilter());

        // Show open dialog; this method does not return until the dialog is closed
        int result = chooser.showOpenDialog(this);

        // Determine which button was clicked to close the dialog
        switch (result)
        {
            case JFileChooser.APPROVE_OPTION:
                File selFile = chooser.getSelectedFile();
                templateTextField.setText(selFile.getAbsolutePath());
                break;
            case JFileChooser.CANCEL_OPTION:
                // Cancel or the close-dialog icon was clicked
                System.out.println("Cancel");
                break;
            case JFileChooser.ERROR_OPTION:
                // The selection process did not complete successfully
                System.out.println("Error");
                break;
        }
    }//GEN-LAST:event_templateButtonActionPerformed

    private void nameTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nameTextFieldActionPerformed
    }//GEN-LAST:event_nameTextFieldActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel centerPanel;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JButton templateButton;
    private javax.swing.JLabel templateLabel;
    private javax.swing.JTextField templateTextField;
    // End of variables declaration//GEN-END:variables
    
}
