/*
 * JSpringOOOPresentation.java
 *
 * Created on 6 juni 2006, 22:06
 */

package nl.reeven.van.nljug.presentation;

import com.sun.star.beans.XPropertySet;
import com.sun.star.drawing.XDrawPage;
import com.sun.star.drawing.XShape;
import com.sun.star.drawing.XShapes;
import com.sun.star.lang.XComponent;
import com.sun.star.presentation.XPresentation;
import com.sun.star.text.XText;
import com.sun.star.text.XTextCursor;
import com.sun.star.text.XTextRange;
import com.sun.star.uno.UnoRuntime;
import java.awt.event.ItemEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import nl.reeven.van.nljug.ooo.OOoHelper;
import nl.reeven.van.nljug.ooo.OOoPresentationHelper;

/**
 *
 * @author  wouter_r
 */
public class JSpringOOOPresentation extends JFrame {
    
    /** Creates new form JSpringOOOPresentation */
    public JSpringOOOPresentation() {
        initComponents();
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        oooHelper = new OOoHelper();
        oooPresentationHelper = new OOoPresentationHelper();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonPanel = new javax.swing.JPanel();
        runButton = new javax.swing.JButton();
        exitButton = new javax.swing.JButton();
        centerPanel = new javax.swing.JPanel();
        templateLabel = new javax.swing.JLabel();
        titleLabel = new javax.swing.JLabel();
        titleTextField = new javax.swing.JTextField();
        remoteLabel = new javax.swing.JLabel();
        remoteCheckBox = new javax.swing.JCheckBox();
        remoteHostLabel = new javax.swing.JLabel();
        remotePortLabel = new javax.swing.JLabel();
        remoteHostTextField = new javax.swing.JTextField();
        remotePortTextField = new javax.swing.JTextField();
        comboPanel = new javax.swing.JPanel();
        templateComboBox = new javax.swing.JComboBox();
        addButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Set presentation settings");
        runButton.setFont(new java.awt.Font("Arial", 1, 24));
        runButton.setText("Run presentation");
        runButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(runButton);

        exitButton.setFont(new java.awt.Font("Arial", 1, 24));
        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(exitButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

        centerPanel.setLayout(new java.awt.GridBagLayout());

        templateLabel.setFont(new java.awt.Font("Arial", 0, 24));
        templateLabel.setText("Select template from list");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(templateLabel, gridBagConstraints);

        titleLabel.setFont(new java.awt.Font("Arial", 0, 24));
        titleLabel.setText("Enter presentation title");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(titleLabel, gridBagConstraints);

        titleTextField.setColumns(40);
        titleTextField.setFont(new java.awt.Font("Arial", 0, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(titleTextField, gridBagConstraints);

        remoteLabel.setFont(new java.awt.Font("Arial", 0, 24));
        remoteLabel.setText("Remote connection");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remoteLabel, gridBagConstraints);

        remoteCheckBox.setFont(new java.awt.Font("Arial", 0, 24));
        remoteCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        remoteCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        remoteCheckBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                remoteCheckBoxItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remoteCheckBox, gridBagConstraints);

        remoteHostLabel.setFont(new java.awt.Font("Arial", 0, 24));
        remoteHostLabel.setText("Remote Host");
        remoteHostLabel.setVisible(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remoteHostLabel, gridBagConstraints);

        remotePortLabel.setFont(new java.awt.Font("Arial", 0, 24));
        remotePortLabel.setText("Remote Port");
        remotePortLabel.setVisible(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remotePortLabel, gridBagConstraints);

        remoteHostTextField.setColumns(30);
        remoteHostTextField.setFont(new java.awt.Font("Arial", 0, 24));
        remoteHostTextField.setVisible(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remoteHostTextField, gridBagConstraints);

        remotePortTextField.setColumns(5);
        remotePortTextField.setFont(new java.awt.Font("Arial", 0, 24));
        remotePortTextField.setVisible(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(remotePortTextField, gridBagConstraints);

        comboPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        templateComboBox.setFont(new java.awt.Font("Arial", 0, 24));
        getTemplatesList();
        for (Iterator it = templateItems.iterator(); it.hasNext();){
            templateComboBox.addItem(it.next());
        }
        comboPanel.add(templateComboBox);

        addButton.setFont(new java.awt.Font("Arial", 1, 24));
        addButton.setText("Add Template");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        comboPanel.add(addButton);

        removeButton.setFont(new java.awt.Font("Arial", 1, 24));
        removeButton.setText("Remove Template");
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        comboPanel.add(removeButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        centerPanel.add(comboPanel, gridBagConstraints);

        getContentPane().add(centerPanel, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void remoteCheckBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_remoteCheckBoxItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            remoteHostLabel.setVisible(true);
            remotePortLabel.setVisible(true);
            remoteHostTextField.setVisible(true);
            remotePortTextField.setVisible(true);
        } else {
            remoteHostLabel.setVisible(false);
            remotePortLabel.setVisible(false);
            remoteHostTextField.setVisible(false);
            remotePortTextField.setVisible(false);
        }
    }//GEN-LAST:event_remoteCheckBoxItemStateChanged

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        if (!((String)templateComboBox.getSelectedItem()).equals("Default")) {
            templateNames.remove((String)templateComboBox.getSelectedItem());
            templateComboBox.removeItem((String)templateComboBox.getSelectedItem());
            String userHome = System.getProperty("user.home");
            File prefsDir = new File(userHome + System.getProperty("file.separator") + PREFSDIR);
            File ooTemplates = new File(prefsDir.getPath() + System.getProperty("file.separator") + PREFSFILE);
            try {
                FileOutputStream out = new FileOutputStream(ooTemplates);
                templateNames.store(out,"--No Comments--");
                out.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }

    }//GEN-LAST:event_removeButtonActionPerformed

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitButtonActionPerformed

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        System.out.println("Maximized_both = " + JFrame.MAXIMIZED_BOTH);
        AddTemplateForm addTemplateForm = new AddTemplateForm(templateNames, templateComboBox);
        addTemplateForm.setVisible(true);
    }//GEN-LAST:event_addButtonActionPerformed

    private void runButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runButtonActionPerformed
        System.out.println("Starting presentation.");
        templateURL = (String)templateNames.get((String)templateComboBox.getSelectedItem());
        System.out.println(templateURL);
        try {
            Object desktop;
            if (remoteCheckBox.isSelected()) {
                desktop = oooHelper.remoteConnect(remoteHostTextField.getText(), remotePortTextField.getText());
            } else {
                desktop = oooHelper.localBootstrap();
            }
            XComponent xPresentationComponent = oooPresentationHelper.getPresentationComponent(desktop, templateURL);
            XPresentation xPresentation = oooPresentationHelper.getPresentation(xPresentationComponent);
            
            oooPresentationHelper.setTitlePage(xPresentationComponent, titleTextField.getText());
            int pageIndex = 1;
            int contentsIndex = 0;
            oooPresentationHelper.addContentsPage(xPresentationComponent, pageIndex++, contentsIndex);
            oooPresentationHelper.addContentsPage(xPresentationComponent, pageIndex++, ++contentsIndex);
            oooPresentationHelper.addHistoryPage(xPresentationComponent, pageIndex++);
            oooPresentationHelper.addContentsPage(xPresentationComponent, pageIndex++, ++contentsIndex);
            oooPresentationHelper.addUnoOverviewPage(xPresentationComponent, pageIndex++);
            oooPresentationHelper.addUnoApiPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addUnoApiConsistsPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addUnoApiDrawbacksPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addUnoApiWorkFlowPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addContentsPage(xPresentationComponent, pageIndex++, ++contentsIndex);
            oooPresentationHelper.addJavaLocalConnectionPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addJavaRemoteConnectionPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addJavaRemoteServerPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addJavaLoadDocument(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addJavaDemoPage(xPresentationComponent, pageIndex++, xPresentation);
            oooPresentationHelper.addJavaTextDocumentsPage(xPresentationComponent, pageIndex++, xPresentation);
            
            oooPresentationHelper.setXPresentation(xPresentation);
            oooPresentationHelper.runPresentation();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Done");
    }//GEN-LAST:event_runButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JSpringOOOPresentation().setVisible(true);
            }
        });
    }
    
// <editor-fold defaultstate="collapsed" desc="Declared variables">
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel centerPanel;
    private javax.swing.JPanel comboPanel;
    private javax.swing.JButton exitButton;
    private javax.swing.JCheckBox remoteCheckBox;
    private javax.swing.JLabel remoteHostLabel;
    private javax.swing.JTextField remoteHostTextField;
    private javax.swing.JLabel remoteLabel;
    private javax.swing.JLabel remotePortLabel;
    private javax.swing.JTextField remotePortTextField;
    private javax.swing.JButton removeButton;
    private javax.swing.JButton runButton;
    private javax.swing.JComboBox templateComboBox;
    private javax.swing.JLabel templateLabel;
    private javax.swing.JLabel titleLabel;
    private javax.swing.JTextField titleTextField;
    // End of variables declaration//GEN-END:variables
    
    private static final String PREFSDIR = ".oopresentation";
    private static final String PREFSFILE = "templates.properties";
    private Vector<String> templateItems = new Vector<String>();
    private Properties templateNames;
    private String templateURL;
    private OOoPresentationHelper oooPresentationHelper;
    private OOoHelper oooHelper;
// </editor-fold>
    
    private void getTemplatesList() {
        String userHome = System.getProperty("user.home");
        File prefsDir = new File(userHome + System.getProperty("file.separator") + PREFSDIR);
        if (!prefsDir.exists()) {
            prefsDir.mkdir();
        }
        File ooTemplates = new File(prefsDir.getPath() + System.getProperty("file.separator") + PREFSFILE);
        if (!ooTemplates.exists()) {
            try {
                templateNames = new Properties();
                FileOutputStream out = new FileOutputStream(ooTemplates);
                templateNames.put("Default","private:factory/simpress");
                templateNames.store(out,"--No Comments--");
                out.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        try {
            templateNames = new Properties();
            FileInputStream in = new FileInputStream(ooTemplates);
            templateNames.load(in);
            in.close();
            for (Enumeration en = templateNames.keys(); en.hasMoreElements();) {
                templateItems.add((String)en.nextElement());
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
